//
//  AuthTokenExtractor.m
//
//  Created on 06.04.10.
//

#import "AuthTokenExtractor.h"

@implementation AuthTokenExtractor

-(id) initWithData:(NSData*)data
{
	if (self = [super init]) {
		xmlParser = [[NSXMLParser alloc] initWithData:data];
		[xmlParser setDelegate: self];
		[xmlParser setShouldResolveExternalEntities:NO];
		currentDataValue = [[NSMutableString alloc] init];
		elementFound = NO;
    }
    return self;
}

-(void)dealloc {
	[xmlParser release];
	[currentDataValue release];
    [super dealloc];
}

-(NSString*) parse
{
	[xmlParser parse];
	return currentDataValue;
}

#pragma mark NSXMLParser delegate methods

// Reduce potential parsing errors by using string constants declared in a single place.
static NSString * const kTokenElementName = @"Token";

-(void)parser:(NSXMLParser *)parser 
		didStartElement:(NSString *)elementName 
		namespaceURI:(NSString *)namespaceURI 
		qualifiedName:(NSString *)qName 
		attributes:(NSDictionary *)attributeDict 
{
	if( [elementName isEqualToString:kTokenElementName])
    {
        elementFound = YES;
    }
}

-(void)parser:(NSXMLParser *)parser 
		didEndElement:(NSString *)elementName 
		namespaceURI:(NSString *)namespaceURI 
		qualifiedName:(NSString *)qName 
{   
	if( [elementName isEqualToString:kTokenElementName])
    {
        elementFound = NO;
    }
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string 
{
	if (elementFound)
    {
        [currentDataValue appendString: string];
    }
}

-(void)parser:(NSXMLParser *)parser 
	parseErrorOccurred:(NSError *)parseError 
{
}

@end
