//
//  MethodListViewController.m
//
//  Created on 08.04.10.
//

#import "MethodListViewController.h"
#import "DataObject.h"
#import "ResultViewController.h"

@implementation MethodListViewController

@synthesize listView;
@synthesize list;
@synthesize isViewPushed;

-(void)dealloc {
    [listView release];
	[list release];
    [super dealloc];
}

- (void)viewDidLoad {
	UIBarButtonItem *backButton = [[UIBarButtonItem alloc] initWithTitle:@"Back"
																  style:UIBarButtonItemStyleBordered
																  target:nil
																  action:nil];
	self.navigationItem.backBarButtonItem = backButton;
	[backButton release];	
}

-(void) viewWillAppear:(BOOL)animated {	
	[super viewWillAppear:animated];	
	self.list = [DataObject getMethodsListForService:self.title];
	[self.listView reloadData];
}	

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [list count];
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"ServiceCell"];
	
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero
									   reuseIdentifier:@"ServiceCell"] autorelease];
    }
	
    cell.textLabel.text = (NSString *)[list objectAtIndex:indexPath.row];
    return cell;
}

// Navigation logic -- create and push a new view controller
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	//Initialize the info view controller.
	if(infoController == nil)
		infoController = [[ResultViewController alloc] initWithNibName:@"ResultViewController" bundle:[NSBundle mainBundle]];				
	UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
	infoController.title = cell.textLabel.text;
	infoController.serviceName = self.title;
	infoController.methodName = cell.textLabel.text;
	infoController.isViewPushed = YES;
	
	//Push the view controller to the top of the stack.
	[self.navigationController pushViewController:infoController animated:YES];
}

@end
