//
//  ResultViewController.m
//
//  Created on 09.04.10.
//

#import "ResultViewController.h"
#import "RkdApiViewAppDelegate.h"
#import "AuthTokenExtractor.h"
#import "DataObject.h"

@implementation ResultViewController

@synthesize isViewPushed;
@synthesize serviceName;
@synthesize methodName;

-(void) viewWillAppear:(BOOL)animated {
	
	[super viewWillAppear:animated];
	
	NSError *error;
	NSURLResponse* response;
	
	NSString* auth = (( RkdApiViewAppDelegate *) [ UIApplication sharedApplication ].delegate).authToken;
	if (auth == nil) {
		return;
	}
	
	NSString* url = [DataObject buldRequestURLByName:serviceName andMethodName:methodName];
	
	NSMutableURLRequest* request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url]];
	
	NSData *body = [DataObject buildHTTPRequestBodyByName:serviceName andMethodName:methodName andAuthToken:auth];
	
	[request setHTTPMethod:@"POST"];
	[request setHTTPBody:body];
	[request setValue:@"application/xml" forHTTPHeaderField:@"Content-type"];	
//	[request setValue:[NSString stringWithFormat:@"%d", body.length] forHTTPHeaderField:@"Content-Legth"];	
	
	[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
	
	// Sending request to proxy
	NSData* data = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
	
	[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
	
	if (error)
	{
		UIAlertView *connectionAlert =
					[[UIAlertView alloc] initWithTitle:@"Connection Failed" 
											message:[NSString stringWithFormat:@"Error: %@",[error localizedDescription]] 
													delegate:self 
													cancelButtonTitle:@"OK" 
													otherButtonTitles:nil];
		[connectionAlert show];
		[connectionAlert release];
	}
	else {
		CGRect webFrame = self.view.bounds;
		UIWebView *webView = [[UIWebView alloc] initWithFrame:webFrame];
		[webView setBackgroundColor:[UIColor whiteColor]];
	
		[webView loadData:data MIMEType:@"text/plain" textEncodingName:@"UTF-8" baseURL:[NSURL URLWithString:@""]];
	
		[self.view addSubview:webView];
		[webView release];
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[serviceName release];
	[methodName release];
    [super dealloc];
}

@end
