//
//  RkdApiViewAppDelegate.m
//
//  Created on 08.04.10.
//

#import "RkdApiViewAppDelegate.h"
#import "ServiceListViewController.h"

#import "AuthTokenExtractor.h"
#import "CredentialsHelper.h"

// Force developer certificate to be trusted
// Comment this function if you istall valid certificate
//
@implementation NSURLRequest(CustomCategory)

+ (BOOL)allowsAnyHTTPSCertificateForHost:(NSString *)host
{
	return YES;
}

@end
//
// end of code to comment

@implementation RkdApiViewAppDelegate

@synthesize window;
@synthesize navigationController;

- (void)applicationDidFinishLaunching:(UIApplication *)application { 
	navigationController.topViewController.title = @"RKD API Viewer";
	[window addSubview:[navigationController view]];
    [window makeKeyAndVisible];
}

- (void)dealloc {
    [window release];
	[navigationController release];
    [super dealloc];
}

-(NSString*)getAuthToken
{
	if (authToken) {
		return authToken;
	}
	NSError *error;
	NSURLResponse* response;

	// Set user credentials
	NSString* auth = [CredentialsHelper getAuthenticationString];

	NSString* url = [CredentialsHelper  getAuthenticationServiceURL];
	
	NSMutableURLRequest* request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url]];
	[request setValue:auth forHTTPHeaderField:@"Authorization"];	
	
    [UIApplication sharedApplication].networkActivityIndicatorVisible = YES;

	NSData* data = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
	
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;

	if (error)
	{
		UIAlertView *connectionAlert = [[UIAlertView alloc] initWithTitle:@"Connection Failed" 
																message:[NSString stringWithFormat:@"Error: %@",[error localizedDescription]] 
																delegate:self 
																cancelButtonTitle:@"OK" 
																otherButtonTitles: nil];
		[connectionAlert show];
		[connectionAlert release];
		return nil;
	}
	else
	{
		AuthTokenExtractor *te = [[AuthTokenExtractor alloc] initWithData:data];
		authToken = [[te parse] retain];
		[te release];
		return authToken;
	}
}

@end
