//
//  ServiceListViewController.m
//
//  Created on 08.04.10.
//

#import "ServiceListViewController.h"
#import "DataObject.h"
#import "MethodListViewController.h"

@implementation ServiceListViewController

@synthesize listView;
@synthesize list;

-(void)dealloc {
    [listView release];
	[list release];
    [super dealloc];
}

-(void)awakeFromNib {
	UIBarButtonItem *backButton = [[UIBarButtonItem alloc] initWithTitle:@"Back"
																  style:UIBarButtonItemStyleBordered
																  target:nil
																  action:nil];
	self.navigationItem.backBarButtonItem = backButton;
	[backButton release];

	self.list = [DataObject getServicesList];
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [list count];
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"ServiceCell"];
	
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero
									   reuseIdentifier:@"ServiceCell"] autorelease];
    }
	
    cell.textLabel.text = (NSString *)[list objectAtIndex:indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic -- create and push a new view controller
	
	//Initialize the info view controller.
	if(tabController == nil)
		tabController = [[MethodListViewController alloc] initWithNibName:@"MethodListViewController" bundle:[NSBundle mainBundle]];				
	UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
	tabController.title = cell.textLabel.text;
	tabController.isViewPushed = YES;
	
	//Push the view controller to the top of the stack.
	[self.navigationController pushViewController:tabController animated:YES];
}

@end
