//
//  CredentialsHelper.m
//
//  Created on 15.04.10.
//

#import "CredentialsHelper.h"

#define	AUTH_HOST_KEY	@"auth_host"
#define	AUTH_BASE64_KEY	@"authorization"
#define SERVICE_URL_KEY	@"service_host"

@implementation CredentialsHelper

static NSDictionary* plistRoot;

+(void)checkLoadData
{
	if (!plistRoot)
	{
		NSString *plistFile = [[NSBundle mainBundle] pathForResource:@"credentials" ofType:@"plist"];
		plistRoot = [[NSDictionary dictionaryWithContentsOfFile:plistFile] retain];
	}
}

+(NSString*)getAuthenticationServiceURL
{
	[CredentialsHelper checkLoadData];
	return [plistRoot valueForKey:AUTH_HOST_KEY];
}

+(NSString*)getAuthenticationString;
{
	[CredentialsHelper checkLoadData];
	return [plistRoot valueForKey:AUTH_BASE64_KEY];
}

+(NSString*)getMainServiceURL;
{
	[CredentialsHelper checkLoadData];
	return [plistRoot valueForKey:SERVICE_URL_KEY];
}

@end
